<?php

class DataArr_Students {
    protected $model;
    
    public function __construct() {
        $this->model = new Model_DataArr_Students;
    }
    
    public function byStudyGroup($groupID)
    {
        $students = $this->model->getStudentsByStudyGroups($groupID);
        return new DataArray_Result($this->generateArray($students));
    }
    
    public function byFaculty($facultyID)
    {
        $students = $this->model->getStudentsByFaculty($facultyID);
        return new DataArray_Result($this->generateArray($students));
    }
    
    public function byGrade($gradeID)
    {
        $students = $this->model->getStudentsByGrade($gradeID);
        return new DataArray_Result($this->generateArray($students));
    }
    
    protected function getDegreeTitle($degree)
    {
        switch($degree)
        {
            case 'bachelor': 
            {
                return 'Бакалавриат';
            }
            case 'specialist': 
            {
                return 'Специалитет';
            }
            case 'master': 
            {
                return 'Магистратура';
            }
                
        }
    }
    
    protected function generateArray($students)
    {
        $studentsHandled = array(); $i = 0;
        foreach($students as $row)
        {
            $i++;
            $studentsHandled[$i]['ID'] = $row['StudentID'];
            $studentsHandled[$i]['AccountID'] = $row['StudentAccID'];
            $studentsHandled[$i]['LastName'] = $row['StudentLast'];
            $studentsHandled[$i]['FirstName'] = $row['StudentFirst'];
            $studentsHandled[$i]['SecondName'] = $row['StudentSecond'];
            $studentsHandled[$i]['GroupID'] = $row['GroupID'];
            $studentsHandled[$i]['GradeID'] = $row['GradeID'];
            $studentsHandled[$i]['GradeNum'] = $row['GroupGrade'];
            $studentsHandled[$i]['Degree'] = $this->getDegreeTitle($row['GroupDegree']);
            $studentsHandled[$i]['GroupNum'] = $row['GroupNum'];
        }
        return $studentsHandled;
    }

    public function forDiscipline($TeacherID, $DisciplineID)
    {
        $students = $this->model->getStudentsForDiscipline($TeacherID, $DisciplineID);
        $studentsHandled = array();
        $i = 0;
        
        foreach($students as $row) {
            $i++;
            $studentsHandled[$i]['StudentID'] = $row['StudentID'];
            $studentsHandled[$i]['LastName'] = $row['LastName'];
            $studentsHandled[$i]['FirstName'] = $row['FirstName'];
            $studentsHandled[$i]['SecondName'] = $row['SecondName'];
            $studentsHandled[$i]['Grade'] = $row['Grade'];
            $studentsHandled[$i]['GroupNum'] = $row['GroupNum'];
            $studentsHandled[$i]['Type'] = $row['Type'];
            $studentsHandled[$i]['GroupID'] = $row['GroupID'];
        }
        return new DataArray_Result($studentsHandled);
    }

    public function NotAttendingDiscipline($GradeID, $GroupN, $FacultyID, $Last, $First, $Second, $DisciplineID)
    {
        $students = $this->model->getStudentsForDiscipline($GradeID, $GroupN, $FacultyID, $Last, $First, $Second, $DisciplineID);
        $studentsHandled = array();
        $i = 0;
        
        foreach($students as $row) {
            $i++;
            $studentsHandled[$i]['StudentID'] = $row['StudentID'];
            $studentsHandled[$i]['StudentLast'] = $row['StudentLast'];
            $studentsHandled[$i]['StudentFirst'] = $row['StudentFirst'];
            $studentsHandled[$i]['StudentSecond'] = $row['StudentSecond'];
            $studentsHandled[$i]['GroupGrade'] = $row['GroupGrade'];
            $studentsHandled[$i]['GroupNum'] = $row['GroupNum'];
            $studentsHandled[$i]['GroupID'] = $row['GroupID'];
        }
         $studentsHandled['count'] = $i;
        return new DataArray_Result($studentsHandled);
    }
}
